﻿@model LoyaltyPointEngine.Model.Parameter.Receipt.UploadReceiptCMSModel
@{
    int detailindex = 0;
}
<!--=== Page Content ===-->
<div class="row">
    <div class="col-md-12">
        <h5 class="widget-title"><i class="icon-sign-blank"></i>Detil Receipt</h5>
    </div>
</div>
@using (Html.BeginForm(MVC.Receipt.Detil(), FormMethod.Post, new { enctype = "multipart/form-data", @class = "form-horizontal row-border", @id = "formAddReceipt" }))
{

    <div class="row">
        <!--=== Validation Example 1 ===-->
        <div class="col-md-12">
            <div class="widget box">
                <div class="widget-header">
                    <h4><i class="icon-reorder"></i>Receipt Header</h4>
                </div>
                <div class="widget-content">
                    @Html.AntiForgeryToken()
                    @Html.HiddenFor(x => x.Code)

                    @if (!Html.ViewData.ModelState.IsValid)
                    {
                        <div class="alert alert-danger">
                            <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                            <i class="fa fa-times-circle"></i>
                            Error occured:
                            <br />
                            @Html.ValidationSummary()
                        </div>
                    }

                    @Html.HiddenFor(x => x.ID)
                    <div class="form-group">
                        <label class="col-md-3 control-label">Member <span class="required">*</span></label>
                        <div class="col-md-6">
                            @Html.HiddenFor(x => x.MemberID)
                            @Html.TextBoxFor(x => x.MemberName, new { @class = "form-control", @readonly = "", @required = "" })
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">Code <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Model.Code
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">Receipt Code </label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.ReceiptCode, new { @class = "form-control", @readonly = "" })
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">Retailer <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.DropDownListFor(x => x.RetailerID, ViewBag.ListRetailer as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @required = "required", @disabled = "disabled" })
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">Retailer Address <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextAreaFor(x => x.RetailerAddress, new { @class = "form-control", @required = "", @readonly = "" })
                        </div>
                    </div>


                    <div class="form-group">
                        <label class="col-md-3 control-label">Transaction Date <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.StrTransactionDate, new { @class = "form-control datepicker", @readonly = "" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Transaction Time <span class="required">*</span></label>
                        <div class="col-md-3">
                            <input type="text" id="StrTransactionTime" name="StrTransactionTime" class="form-control" data-mask="99:99:99" value="@Model.StrTransactionTime" disabled><span class="help-block">HH:MM:SS</span>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">Image</label>
                        <div class="col-md-9">

                            <div class="slickiiii">
                                @if (Model.Image != null && Model.Image.Count() > 0)
                                {
                                    string imageHost = Settings.GetValueByKey(LoyaltyPointEngine.Common.SiteSetting.ASSET_URL);
                                    foreach (string imageurl in Model.Image)
                                    {
                                        string imagefullUrl = imageHost + imageurl;
                                        <a href="#" onclick="readURL('@imagefullUrl')" data-toggle="modal" data-target="#imageViewer">
                                            <div class="item">
                                                <img src="@imagefullUrl" alt="">
                                            </div>
                                        </a>
                                    }
                                }
                            </div>
                        </div>
                    </div>
                    <input id="TotalAction" name="TotalAction" type="hidden" value="@Model.ReceiptDetails.Count()">
                    <div style="display: none">
                        @Html.DropDownListFor(x => x.ActionDummy, ViewBag.ListAction as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix" })
                    </div>
                </div>
            </div>
            <!-- /Validation Example 1 -->
        </div>
    </div>

    foreach (LoyaltyPointEngine.Model.Parameter.Receipt.UploadReceiptDetailCMSModel detail in Model.ReceiptDetails)
    {
        detailindex++;
        int quantityApproved = detail.QuantityApproved == null ? detail.Quantity : detail.QuantityApproved;
        int totalpoint = detail.Points * quantityApproved;
        <div id="action-box">
            <div class="row action-obj-@detailindex">
                <div class="col-md-12">
                    <div class="widget box">
                        <div class="widget-header">
                            <h4><i class="icon-reorder"></i>Receipt Detail</h4>
                            @*@if (detailindex > 1)
                            {
                            <!-- Toolbar -->
                                <div class="toolbar no-padding">
                                    <div class="btn-group" onclick="removeAction(@detailindex)">
                                        <span class="btn btn-xs"><i class="icon-minus"></i>Remove</span>
                                    </div>
                                </div>
                            <!-- /Toolbar -->
                            }*@
                        </div>
                        <div class="widget-content">
                            <div class="form-group">
                                <label class="col-md-3 control-label">Action <span class="required">*</span></label>
                                <div class="col-md-9">
                                    <select id="ActionID-@detailindex" name="ActionID-@detailindex" class="select2-select-00 col-md-12 full-width-fix" onchange="GetActionValue(this.value, @detailindex)" required disabled>
                                        <option></option>
                                        @foreach (SelectListItem item in ViewBag.ListAction)
                                        {
                                            string selected = (detail.ActionID.ToString() == item.Value) ? "selected" : string.Empty;
                                            <option value="@item.Value" @selected>@item.Text</option>
                                        }
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-md-3 control-label">Quantity <span class="required">*</span></label>
                                <div class="col-md-9">
                                    <input class="form-control" id="Quantity-@detailindex" name="Quantity-@detailindex" onchange="SetTotalPoint(this.value, @detailindex)" required value="@detail.Quantity" type="text" disabled>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Points</label>
                                <div class="col-md-9">
                                    <input class="form-control" id="Points-@detailindex" name="Points-@detailindex" readonly="" value="@detail.Points" type="text" disabled>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Quantity Approved</label>
                                <div class="col-md-9">
                                    <input class="form-control" id="QuantityApproved-@detailindex" name="QuantityApproved-@detailindex" onchange="SetTotalQuantityPoint(this.value, @detailindex)" value="@detail.QuantityApproved" type="text" required disabled>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Total Quantity Approved Points</label>
                                <div class="col-md-9">
                                    <input class="form-control TotalQuantityApproved" id="TotalQuantityApprovedPoints-@detailindex" name="TotalQuantityApprovedPoints-@detailindex" readonly="" value="@totalpoint" type="text" disabled>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Remarks</label>
                                <div class="col-md-9">
                                    <textarea class="form-control" id="Remarks-@detailindex" name="Remarks-@detailindex" readonly="readonly">@detail.Remarks</textarea>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    }
    <div class="row">
        <div class="col-md-12 ta-center">
            <label class="col-md-2 control-label">Total All </label>
            <div class="col-md-2">
                <input class="form-control" id="TotalAllPoint" name="TotalAllPoint" type="text" value="0" readonly>
            </div>
            <div class="col-md-3" style="display: none">
                <a href="@Url.Action(MVC.Receipt.Index())" class="btn btn-danger">Close</a>
            </div>
        </div>
    </div>
    <div class="row">
        <br />
    </div>
}

<div class="modal fade" id="memberModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" style="width: auto !important" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Select Member</h4>
            </div>
            <div class="modal-body">
                <div>
                    @using (Html.BeginForm(null, null, null, FormMethod.Post, new { id = "gridSeachMember", Member = "form" }))
                    {
                        <input type="text" id="txtSearch" name="txtSearch" class="form-control box-search" placeholder="Search for...">
                        <button class="hidden" type="submit"></button>
                    }
                </div>

                @Html.Action("GridGetSelectMember", "Member")
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="imageViewer" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">View Image</h4>
            </div>
            <div class="modal-body">
                <div>
                    <img id="blah" src="#" alt="your image" />
                </div>

            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="RejectModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Form Reject Receipt</h4>
            </div>
            @using (Html.BeginForm(MVC.Receipt.Reject(), FormMethod.Post, new { enctype = "multipart/form-data", @class = "form-horizontal row-border", @id = "formRejectReceipt" }))
            {
                <div class="modal-body">
                    <div>
                        <div class="row">
                            <!--=== Validation Example 1 ===-->
                            <div class="col-md-12">
                                <div class="widget box">
                                    <div class="widget-content">
                                        <div class="form-group">
                                            <label class="col-md-3 control-label">Reason <span class="required">*</span></label>
                                            <div class="col-md-9">
                                                @Html.HiddenFor(x => x.ID)
                                                <textarea id="Reason" name="Reason" class="form-control" required>@Model.RejectReason</textarea>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <label class="col-md-3 control-label">Is Need Reupload: </label>
                                            <div class="col-md-9">
                                                @Html.CheckBoxFor(x => x.IsNeedReuploadData, new { @class = "uniform" })

                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!-- /Validation Example 1 -->
                            </div>
                        </div>
                    </div>

                </div>

                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                    <a href="javascript:void(0)" onclick="RejectDocument()" class="btn btn-danger" data-dismiss="modal">Reject Receipt</a>
                </div>

            }
        </div>
    </div>
</div>
@section FooterScript{
    <script>
        function GetAllTotalPoint() {
            var total = 0;
            $('.TotalQuantityApproved').each(function () {
                total += parseInt(this.value);
            });
            return total;
        }
        function readURL(url) {
            $('#blah').attr('src', url);
        }
        (function () {
            var gridName = 'GridSelectMember';
            var pagingUrl = '@Url.Action(MVC.Member.GridGetSelectMemberPager())';

        $('.grid-mvc').gridmvc();
        pageGrids[gridName].ajaxify({
            getData: pagingUrl,
            getPagedData: pagingUrl,
            gridFilterForm: $('#gridSeachMember')
        });
    }())

    //function ini dipanggil sama popup Member
    function SelectMember(MemberID, MemberName) {
        $('#MemberID').val(MemberID);
        $('#MemberName').val(MemberName);
        $('#memberModal').modal('hide');
    };


    function GetActionValue(val, index) {
        _url = '@Url.Action(MVC.Action.GetActionValueById(999999999))';
            _url = _url.replace("999999999", val);
            $.ajax({
                url: _url,
                timeout: 30000,
                success: function (msg) {
                    $('#Points-' + index).val(msg.value);
                    $('#QuantityApproved-' + index).val(0);
                    $('#TotalQuantityApprovedPoints-' + index).val(msg.value);
                    var _TotalPoint = GetAllTotalPoint();
                    $('#TotalAllPoint').val(_TotalPoint);
                    if (msg.isCampaign)
                        alert("Campaign " + msg.campaignName + " is Active");
                },
                error: function (jqXHR, textStatus) {
                    alert('Error Occured'); //MESSAGE
                }
            })
        }

        function SetTotalPoint(val, index) {
            var actionPoint = $('#Points-' + index).val();
            var total = actionPoint * val;
            $('#QuantityApproved-' + index).val(val);
            $('#TotalQuantityApprovedPoints-' + index).val(total);
            var _TotalPoint = GetAllTotalPoint();
            $('#TotalAllPoint').val(_TotalPoint);
        }
        function SetTotalQuantityPoint(val, index) {
            var actionPoint = parseInt($('#Points-' + index).val());
            var quantityVal = parseInt($('#Quantity-' + index).val());


            if (val > quantityVal) {
                alert('Quantity Approved should be less than or equal to Quantity');
                $('#QuantityApproved-' + index).val(quantityVal);
            } else {
                var total = actionPoint * val;
                $('#TotalQuantityApprovedPoints-' + index).val(total);
                var _TotalPoint = GetAllTotalPoint();
                $('#TotalAllPoint').val(_TotalPoint);
            }
        }
        function InitialSlick() {
            $('.slickiiii').slick({
                infinite: false,
                slidesToShow: 2,
                slidesToScroll: 1
            });
        }
        //validation
        $(document).ready(function () {
            InitialSlick()
            //set total all
            var _TotalPoint = GetAllTotalPoint();
            $('#TotalAllPoint').val(_TotalPoint);

            //===== Validation =====//
            //for default options, see assets/js/plugins.form-components.js (initValidation())

            $.extend($.validator.defaults, {
                invalidHandler: function (form, validator) {
                    var errors = validator.numberOfInvalids();
                    if (errors) {
                        var message = errors == 1
                        ? 'You missed 1 field. It has been highlighted.'
                        : 'You missed ' + errors + ' fields. They have been highlighted.';
                        noty({
                            text: message,
                            type: 'error',
                            timeout: 2000
                        });
                    }
                },
                errorPlacement: function (error, element) {
                    if (element.attr('type') === "file" && element.data('style') === "fileinput") {
                        error.appendTo(element.closest("div.fileinput-holder").parent('div'));
                    } else {
                        error.insertAfter(element)
                    }
                }
            });

            $("#formAddRedeem").validate();

        });
    </script>
    <script type="text/javascript">
        var frm = $('#formAddReceipt');
        var strAlert = '';
        frm.submit(function (ev) {
            ShowLoader();
            $.ajax({
                type: frm.attr('method'),
                url: frm.attr('action'),
                data: frm.serialize(),
                success: function (data) {
                    HideLoader();
                    strAlert += data.Message;
                    alert(strAlert);
                    if (data.IsSuccess) {
                        window.location.href = "@Url.Action(MVC.Receipt.Index())";
                }
            }
        });

        strAlert = '';
        ev.preventDefault();
    });

    var frmReject = $('#formRejectReceipt');
    function RejectDocument() {
        ShowLoader();
        $.ajax({
            type: frmReject.attr('method'),
            url: frmReject.attr('action'),
            data: frmReject.serialize(),
            success: function (data) {
                strAlert = "";
                HideLoader();
                strAlert += data.Message;
                alert(strAlert);
                if (data.IsSuccess) {
                    window.location.href = "@Url.Action(MVC.Receipt.Index())";
                    }
                }
            });
        }
    </script>
    <style>
        .slickiiii {
            width: 240px;
        }

            .slickiiii .item {
                width: 100px;
                height: 150px;
                margin: 2px 5px;
            }

                .slickiiii .item img {
                    max-width: 100%;
                    min-width: 100%;
                    max-height: 100%;
                    min-height: 100%;
                    object-fit: cover;
                }

            .slickiiii .slick-prev, .slickiiii .slick-next {
                background: #808080;
                height: 50px;
            }

            .slickiiii .slick-disabled {
                opacity: 0.4;
            }
    </style>
}

